#region usings

using System;
using System.Runtime.InteropServices; 
using VVVV.PluginInterfaces.V2;

#endregion usings

//author: ivo (aivenhoe)
//though, more or less just copied from the www. sunep showed me a similar plugin (which i think was written by u7angel). but i didn't have it and i found it cool, so i implemented it by myself.

namespace VVVV.Nodes
{
	[PluginInfo(Name = "BatteryStatus", Category = "System", Help = "Returns your computer's battery status as charged percentage and a boolean value whether your powersupply is plugged in or not", Tags = "Battery, Charge, aivenhoe")]
	public class test_batteryTemplate : IPluginEvaluate
	{
		#region fields & pins
		[Output("BatteryState")]
		ISpread<double> FBatteryPercentage;
	
		[Output("ACPowerPluggedIn")]
		ISpread<bool> FACPowerpluggedIn;
		#endregion fields & pins

     	[DllImport("kernel32.dll", SetLastError = true)]
   		private static extern Boolean GetSystemPowerStatus(out SystemPowerStatus sps);

		#region batterystuff  
  		private enum ACLineStatus : byte
   	 	{
      		Offline = 0, 
      		Online = 1, 
//		 	Unknown = 255,
		}

  		private enum BatteryFlag : byte
	  	{
    		High = 1,
    		Low = 2,
    		Critical = 4,
 			Charging = 8,
  			NoSystemBattery = 128,
  			Unknown = 255,
		 }

		private struct SystemPowerStatus
    	{	
     		public ACLineStatus LineStatus;
		   	public BatteryFlag flgBattery;
			public Byte BatteryLifePercent;
  		   	public Byte Reserved1;
 		    public Int32 BatteryLifeTime;
    		public Int32 BatteryFullLifeTime;
   		}
	
		public static Boolean ACPowerPluggedIn()
  	  	{
   		  	SystemPowerStatus SPS = new SystemPowerStatus();
      		GetSystemPowerStatus(out SPS);
		    if (SPS.LineStatus == ACLineStatus.Online)
          		return true;
      		else
          		return false;
  		}

		public static double BatteryCharge()
    	{
      		SystemPowerStatus SPS = new SystemPowerStatus();
      		GetSystemPowerStatus(out SPS);
   			return (double)SPS.BatteryLifePercent*0.01;
    	}
	
#endregion batterystuff  	
	
	public void Evaluate(int SpreadMax)
		{	
			FBatteryPercentage[0]=BatteryCharge();
		    FACPowerpluggedIn[0]=ACPowerPluggedIn();
		}
	}
}
